#include "helper.h"

void setup_tree(void) {
  GtkWidget *tree1 = lookup_widget(a, "treeview4"),
            *tree2 = lookup_widget(a, "treeview5");
  GtkTreeViewColumn *column;
  GtkCellRenderer *rend_disc, *rend_group, *rend_track, *rend_other;
  GtkTargetEntry target_entry;
  GtkTreeStore *store2;

  gtk_signal_connect(GTK_OBJECT(tree1), "row-activated",
                     GTK_SIGNAL_FUNC(on_row_activated), NULL);

  gtk_signal_connect(GTK_OBJECT(tree1), "cursor-changed",
                     GTK_SIGNAL_FUNC(on_cursor_changed), NULL);

  target_entry.target = "netmdtrack";
  target_entry.flags = GTK_TARGET_SAME_APP & GTK_TARGET_SAME_WIDGET;
  target_entry.info = 7;
  gtk_tree_view_enable_model_drag_source(GTK_TREE_VIEW(tree2), GDK_BUTTON1_MASK,
                                         &target_entry, 1, GDK_ACTION_MOVE);
  gtk_tree_view_enable_model_drag_dest(GTK_TREE_VIEW(tree2), &target_entry, 1,
                                       GDK_ACTION_MOVE);
  /*
  gtk_signal_connect(GTK_OBJECT(store), "row_changed", GTK_SIGNAL_FUNC(on_row_changed), NULL);
  gtk_signal_connect(GTK_OBJECT(store), "row_inserted", GTK_SIGNAL_FUNC(on_row_inserted), NULL);
  gtk_signal_connect(GTK_OBJECT(store), "row_deleted", GTK_SIGNAL_FUNC(on_row_deleted), NULL);
  gtk_signal_connect(GTK_OBJECT(store), "rows_reordered", GTK_SIGNAL_FUNC(on_rows_reordered), NULL);
  */

  rend_disc = gtk_cell_renderer_text_new();
  g_object_set(G_OBJECT(rend_disc), "editable", TRUE, NULL);

  rend_group = gtk_cell_renderer_text_new();
  g_object_set(G_OBJECT(rend_group), "editable", FALSE, NULL);
  gtk_signal_connect(GTK_OBJECT(rend_group), "edited",
                     GTK_SIGNAL_FUNC(on_rename_group), NULL);

  rend_track = gtk_cell_renderer_text_new();
  g_object_set(G_OBJECT(rend_track), "editable", TRUE, NULL);
  gtk_signal_connect(GTK_OBJECT(rend_track), "edited",
                     GTK_SIGNAL_FUNC(on_rename_track), NULL);

  rend_other = gtk_cell_renderer_text_new();

  column = gtk_tree_view_column_new_with_attributes(
      0, rend_group, "text", 0, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (tree1), column);

  gtk_tree_view_column_set_cell_data_func(column, rend_group, mycellfunc, 0, 0);

  column = gtk_tree_view_column_new_with_attributes(
      "#", rend_other, "text", TRACK_COLUMN, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (tree2), column);

  column = gtk_tree_view_column_new_with_attributes(
      "Title", rend_track, "text", TITLE_COLUMN, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (tree2), column);

  column = gtk_tree_view_column_new_with_attributes(
      "Length", rend_other, "text", LENGTH_COLUMN, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(tree2), column);

  column = gtk_tree_view_column_new_with_attributes(
      "Codec", rend_other, "text", CODEC_COLUMN, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(tree2), column);

  column = gtk_tree_view_column_new_with_attributes(
      "Mode", rend_other, "text", MODE_COLUMN, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(tree2), column);

  column = gtk_tree_view_column_new_with_attributes(
      "Size", rend_other, "text", SIZE_COLUMN, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(tree2), column);

  column = gtk_tree_view_column_new_with_attributes(
      "Status", rend_other, "text", STATUS_COLUMN, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(tree2), column);

  store2 = gtk_tree_store_new(N_COLUMNS, G_TYPE_INT, G_TYPE_STRING,
                              G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING,
                              G_TYPE_STRING, G_TYPE_STRING);
  gtk_tree_view_set_model(GTK_TREE_VIEW(tree2), GTK_TREE_MODEL(store2));
  g_object_unref(G_OBJECT(store2));
}
